## org.springframework.transaction.jta
Class WebSphereTransactionManagerFactoryBean

    java.lang.Object
      org.springframework.transaction.jta.WebSphereTransactionManagerFactoryBean

All Implemented Interfaces:
  FactoryBean

    public class WebSphereTransactionManagerFactoryBean

extends Object
implements FactoryBean

`FactoryBean` that retrieves the JTA TransactionManager for IBM's WebSphere application servers (versions 5.1, 6.0 and 6.1).

Uses WebSphere's static accessor methods to obtain the internal JTA TransactionManager. This is known to work reliably on all tested WebSphere versions; however, access to the internal TransactionManager facility is not officially supported by IBM.

In combination with Spring's JtaTransactionManager, this FactoryBean can be used to enable transaction suspension (PROPAGATION_REQUIRES_NEW, PROPAGATION_NOT_SUPPORTED) on WebSphere:

     <bean id="wsJtaTm" class="org.springframework.transaction.jta.WebSphereTransactionManagerFactoryBean"/>

     <bean id="transactionManager" class="org.springframework.transaction.jta.JtaTransactionManager">
       <property name="transactionManager ref="wsJtaTm"/>
     </bean>

Note that Spring's JtaTransactionManager will continue to use the JTA UserTransaction for standard transaction demarcation, as defined by standard J2EE. It will only use the provided WebSphere TransactionManager in case of actual transaction suspension needs. If you do not require transaction suspension in the first place, do not bother with this FactoryBean.

NOTE: On recent WebSphere 6.0.x and 6.1.x versions, this class has been superseded by the `WebSphereUowTransactionManager` class, which uses IBM's official UOWManager API facility for transaction suspension. The WebSphereUowTransactionManager class is a direct replacement for a standard JtaTransactionManager definition, without further configuration.

Since:
  21.01.2004
Author:
  Juergen Hoeller
See Also:
  `JtaTransactionManager.setTransactionManager(javax.transaction.TransactionManager)`, `com.ibm.ws.Transaction.TransactionManagerFactory#getTransactionManager`, `WebSphereUowTransactionManager`

Field Summary
`protected Log` `logger`

Constructor Summary
`WebSphereTransactionManagerFactoryBean()` This constructor retrieves the WebSphere TransactionManager factory class, so we can get access to the JTA TransactionManager.

Method Summary
`Object` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` `isSingleton()` Is the object managed by this factory a singleton?

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final Log logger

Constructor Detail

### WebSphereTransactionManagerFactoryBean

    public WebSphereTransactionManagerFactoryBean()
                                           throws TransactionSystemException

  This constructor retrieves the WebSphere TransactionManager factory class, so we can get access to the JTA TransactionManager.

  Throws:
    `TransactionSystemException`

Method Detail

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

Copyright © 2002-2008 The Spring Framework.